package master.koitoyuu.ui.login;
import master.koitoyuu.utils.BlurUtils;
import master.koitoyuu.utils.RenderUtils2;
import net.ccbluex.liquidbounce.ui.font.Fonts;
import net.ccbluex.liquidbounce.utils.render.RenderUtils;
import net.minecraft.client.Minecraft;
import net.minecraft.client.gui.FontRenderer;
import net.minecraft.client.gui.Gui;
import net.minecraft.client.gui.GuiButton;
import net.minecraft.util.StringUtils;

import java.awt.*;

public class LoginButton extends GuiButton {
    public int cs;
    public int alpha;
    private int color;

    public LoginButton(int buttonId, int x, int y, int widthIn, int heightIn, String buttonText) {
        super(buttonId, x, y, widthIn, heightIn, buttonText);
    }

    @Override
    public void drawButton(Minecraft mc, int mouseX, int mouseY) {
        Color color1 = new Color(0F, 0F, 0F, this.alpha / 255.0F);
        int col1 = color1.getRGB();
        if (this.visible) {
            FontRenderer var4 = Fonts.regular40;
            this.hovered = (mouseX >= this.xPosition && mouseY >= this.yPosition && mouseX < this.xPosition + this.width && mouseY < this.yPosition + this.height);
            updatefade();

            BlurUtils.INSTANCE.draw(this.xPosition,this.yPosition,this.width,this.height,15f);
            if (this.enabled) {
                Gui.drawRect((this.xPosition + this.cs), this.yPosition, (this.xPosition + this.width - this.cs), (this.yPosition + this.height), col1);

                RenderUtils2.drawShadow((this.xPosition + this.cs), this.yPosition, (this.width - this.cs), (this.height));
            } else {
                Gui.drawRect(this.xPosition, this.yPosition, (this.xPosition + this.width), (this.yPosition + this.height), (new Color(0.5F, 0.5F, 0.5F, 0.5F)).hashCode());
                RenderUtils2.drawShadow((this.xPosition + this.cs), this.yPosition, (this.width - this.cs), (this.height));//RenderUtils2.drawGradientSideways(this.xPosition, this.yPosition + this.height - 1, (this.xPosition + this.width) - this.width / 2, (this.yPosition + this.height), new Color(31,31,31,255).getRGB(), new Color(61,61,61,255).getRGB());
            }
            mouseDragged(mc, mouseX, mouseY);
            int var5 = 14737632;
            drawCenteredString(var4, StringUtils.stripControlCodes(this.displayString), this.xPosition + this.width / 2, this.yPosition + (this.height - 5) / 2 - 2, var5);
        }
    }

    private void updatefade() {
        if (this.enabled)
            if (this.hovered) {
                this.alpha += 25;
                if (this.alpha >= 210)
                    this.alpha = 210;
            } else {
                this.alpha -= 25;
                if (this.alpha <= 120)
                    this.alpha = 120;
            }
    }
    public void updateCoordinates(float x, float y) {
        xPosition = (int) x;
        yPosition = (int) y;
    }

    public void setColor(int color) {
        this.color = color;
    }

    public boolean hovered(int mouseX, int mouseY) {
        return mouseX >= this.xPosition && mouseY >= this.yPosition && mouseX < this.xPosition + this.width && mouseY < this.yPosition + this.height;
    }
}